#include <iostream>
#include <array>
#include <stdio.h>

using namespace std;

int main()
{
    int n,k;
    cin>>n>>k;
    int matrica[n][n];
    int broj=0;
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
            cin>>matrica[i][j];
    }
    int levi[k][1];
    int desni[k][1];
    int gornji[k][1];
    int donji[k][1];
    bool nesto;
    for(int i=1;i<=k;i++)
    {
        nesto=false;
        levi[i][0]=n;
        desni[i][0]=-1;
        gornji[i][0]=n;
        donji[i][0]=-1;
        for(int j=0;j<n;j++)
        {
            for(int m=0;m<n;m++)
            {
                if(matrica[j][m]==i && m<=levi[i][0])
                {
                    levi[i][0]=m;

                }
                if(matrica[j][m]==i && m>=desni[i][0])
                {
                    desni[i][0]=m;

                }
                if(matrica[j][m]==i && j<=gornji[i][0])
                {
                    gornji[i][0]=j;

                }
                if(matrica[j][m]==i && j>=gornji[i][0])
                {
                    donji[i][0]=j;

                }
            }
        }

        for(int j=gornji[i][0];j<=donji[i][0];j++)
        {
            for(int m=levi[i][0];m<=desni[i][0];m++)
            {
                if(matrica[j][m]!=i)
                {
                    nesto=true;
                }
            }
        }
        if(levi[i][0]==n && desni[i][0]==-1 && gornji[i][0]==n && donji[i][0]==-1)
            nesto=true;
        if(nesto==false)
            broj++;
    }
    cout<<broj;
    return 0;
}